def t_4(var):
    if var == 1:
        text = """По содержащейся в файле ЭкзБ_1-4.csv реализации выборки из двумерного нормального распределения N((E(X); E(Y)); (Var(X) Cov(X,Y); Cov(X,Y) Var(Y))) = N((0;0); (σ² ρσ; ρσ σ²)) с неизвестными параметрами θ₁ = σ² > 0 и θ₂ = ρ ∈ (-1; 1) запишите логарифм функции правдоподобия L(ρ, σ) и вычислите оценки максимального правдоподобия неизвестных параметров σ² и ρ.
Решение:
1.	Плотность двумерного нормального распределения (с μₓ = μᵧ = 0 и σₓ² = σᵧ² = σ²):
f(x, y; σ², ρ) = (1/(2πσ²√(1-ρ²))) * exp{-[x² - 2ρxy + y²]/(2σ²(1-ρ²))}
2.	Функция правдоподобия для выборки (x₁, y₁), (x₂, y₂), ..., (xₙ, yₙ):
L(σ², ρ) = Πᵢ f(xᵢ, yᵢ; σ², ρ) = (1/(2πσ²√(1-ρ²)))ⁿ * exp{-(1/(2σ²(1-ρ²))) * Σᵢ [xᵢ² - 2ρxᵢyᵢ + yᵢ²]}
3.	Логарифм функции правдоподобия:
ln L(σ², ρ) = -n ln(2π) - n ln(σ²) - (n/2) ln(1-ρ²) - (1/(2σ²(1-ρ²))) * Σᵢ [xᵢ² - 2ρxᵢyᵢ + yᵢ²]
4.	Находим частные производные по σ² и ρ и приравниваем их к нулю:
o	Производная по σ²:
∂(ln L)/∂(σ²) = -n/σ² + (1/(2(σ²)²(1-ρ²))) * Σᵢ [xᵢ² - 2ρxᵢyᵢ + yᵢ²] = 0
Отсюда:
σ̂² = (1/(2n(1-ρ²))) * Σᵢ [xᵢ² - 2ρxᵢyᵢ + yᵢ²]
o	Производная по ρ:
∂(ln L)/∂ρ = (nρ/(1-ρ²)) + (1/(2σ²(1-ρ²)²)) * Σᵢ [xᵢ² - 2ρxᵢyᵢ + yᵢ²] * 2ρ - (1/(2σ²(1-ρ²)²)) * Σᵢ -2xᵢyᵢ = 0
После упрощений:
ρ̂ = (Σᵢ xᵢyᵢ) / (Σᵢ (xᵢ² + yᵢ²))
5.	Подстановка ρ̂ в выражение для σ̂²:
6.	σ̂² = (1/(2n)) * Σᵢ [xᵢ² - 2 * ((Σᵢ xᵢyᵢ) / (Σᵢ (xᵢ² + yᵢ²))) * xᵢyᵢ + yᵢ²]
7.	σ̂² = (1/(2n)) * Σᵢ [xᵢ² + yᵢ²] - (1/n) * ((Σᵢ xᵢyᵢ)² / (Σᵢ (xᵢ² + yᵢ²)))
8.	
9.	Или, чаще используемая форма:
10.	σ̂² = (1/n) * Σᵢ (xᵢ² + yᵢ² - 2ρ̂xᵢyᵢ)
Окончательные оценки максимального правдоподобия:
•	ρ̂ = (Σᵢ xᵢyᵢ) / (Σᵢ (xᵢ² + yᵢ²))
•	σ̂² = (1/n) * Σᵢ (xᵢ² + yᵢ² - 2ρ̂xᵢyᵢ)
        """
    if var == 2:
        text = """Для трех групп финансовых показателей A, B, C проверяется гипотеза о совпадении ожидаемых значений показателей. Предполагается, что все показатели Xij независимы и распределены по нормальному закону N(μj, σ²) с одинаковой неизвестной дисперсией Var(Xij) = σ², причем для каждой группы E(Xij) = μj, j = 1, 2, 3. 1) По данным значениям (файл ЭкзБ_2-4.csv) найдите межгрупповую и среднюю групповую дисперсии. 2) Найдите 92% доверительные интервалы для ожидаемых значений показателей μj, j = 1, 2, 3. 3) Найдите значение статистики критерия F₀, критическое множество Kα и на 4% уровне значимости проверьте гипотезу о совпадении ожидаемых значений показателей, μ₁ = μ₂ = μ₃. 4) Найдите P-значение критерия и сделайте выводы.

Решение:

Python

import numpy as np
import pandas as pd
import scipy.stats as st

def calculate_anova(data):
    ""Вычисляет MSB, MSW и F-статистику.""
    k = len(data)  # Количество групп
    n = [len(group) for group in data] # Размеры групп
    N = sum(n)      # Общее количество наблюдений
    group_means = [np.mean(group) for group in data]
    total_mean = np.mean(np.concatenate(data))

    SSB = sum(ni * (mean - total_mean)**2 for ni, mean in zip(n, group_means))
    SSW = sum(np.sum((group - group_means[i])**2) for i, group in enumerate(data))

    MSB = SSB / (k - 1)
    MSW = SSW / (N - k)
    F = MSB / MSW
    return MSB, MSW, F, N-k, group_means, n

def calculate_confidence_interval(group_mean, MSW, group_size, df, alpha=0.08):
    ""Вычисляет доверительный интервал.""
    t_crit = st.t.ppf(1-alpha/2, df)
    margin_of_error = t_crit * np.sqrt(MSW / group_size)
    return (group_mean - margin_of_error, group_mean + margin_of_error)

try:
    data_pd = pd.read_csv('ЭкзБ_2-4.csv')
    data = [data_pd['A'].dropna().values, data_pd['B'].dropna().values, data_pd['C'].dropna().values]

    MSB, MSW, F, df, group_means, group_sizes = calculate_anova(data)
    print(f"MSB: {MSB:.4f}, MSW: {MSW:.4f}, F: {F:.4f}")

    alpha = 0.04
    f_crit = st.f.ppf(1-alpha, 2, df)
    print(f"Критическое значение F (alpha=0.04, df1=2, df2={df}): {f_crit:.4f}")
    p_value = 1 - st.f.cdf(F, 2, df)
    print(f"P-значение: {p_value:.4f}")

    for i in range(len(data)):
        ci = calculate_confidence_interval(group_means[i], MSW, group_sizes[i], df)
        print(f"92% CI для μ{i+1}: {ci}")

    # Интерпретация результатов
    if F > f_crit:
        print("F-статистика больше критического значения. Нулевая гипотеза о равенстве средних отвергается на уровне значимости 4%.")
        if p_value < alpha:
            print("P-значение меньше уровня значимости 0.04. Нулевая гипотеза о равенстве средних отвергается.")
        else:
            print("P-значение больше уровня значимости 0.04. Нет достаточных оснований отвергнуть нулевую гипотезу.")

except FileNotFoundError:
    print("Ошибка: Файл ЭкзБ_2-4.csv не найден.")
except KeyError as e:
    print(f"Ошибка: столбец {e} не найден в файле.")
except Exception as e:
    print(f"Произошла ошибка: {e}")
        """
    if var == 3:
        text = """4. Пусть (X₁, Y₁); ...; (X₂₉, Y₂₉) — реализация случайной выборки из двумерного нормального распределения N(μₓ, μᵧ, σₓ², σᵧ², ρ). Используя векторы X = (X₁, ..., X₂₉) и Y = (Y₁, ..., Y₂₉), постройте асимптотический 0,94-доверительный интервал (θ₁, θ₂) для коэффициента корреляции ρ. В ответе укажите: 1) выборочный коэффициент корреляции ρ̂; 2) верхнюю границу θ₂ построенного доверительного интервала для ρ. Исходные данные в файле ЭкзБ_3-4.csv.
        import numpy as np
import pandas as pd
import scipy.stats as st

try:
    data = pd.read_csv('ЭкзБ_3-4.csv')
    x = data['X'].values
    y = data['Y'].values

    # 1) Выборочный коэффициент корреляции
    rho_hat = np.corrcoef(x, y)[0, 1]
    print(f"Выборочный коэффициент корреляции ρ̂: {rho_hat:.4f}")

    n = len(x)
    alpha = 1 - 0.94  # Уровень значимости
    z_crit = st.norm.ppf(1 - alpha/2)  # Z-критическое значение

    # Преобразование Фишера
    z_rho_hat = 0.5 * np.log((1 + rho_hat) / (1 - rho_hat))
    se_z = 1 / np.sqrt(n - 3)  # Стандартная ошибка преобразования

    # Доверительный интервал для z_rho
    z_lower = z_rho_hat - z_crit * se_z
    z_upper = z_rho_hat + z_crit * se_z

    # Обратное преобразование Фишера для получения интервала для ρ
    lower = (np.exp(2 * z_lower) - 1) / (np.exp(2 * z_lower) + 1)
    upper = (np.exp(2 * z_upper) - 1) / (np.exp(2 * z_upper) + 1)

    print(f"Асимптотический 0.94-доверительный интервал для ρ: ({lower:.4f}, {upper:.4f})")
    print(f"Верхняя граница θ₂: {upper:.4f}") # 2) Верхняя граница

except FileNotFoundError:
    print("Ошибка: Файл ЭкзБ_3-4.csv не найден.")
except KeyError as e:
    print(f"Ошибка: столбец {e} не найден в файле.")
except Exception as e:
    print(f"Произошла ошибка: {e}")
        """
    if var == 4:
        text = """Пусть выборка состоит из одного единственного наблюдения X₁ с плотностью f(x) = 1/(π(1+(x-θ)²)) (плотность распределения Коши). Что собой представляет при разных значениях c критическое множество критерия Неймана-Пирсона для проверки гипотезы H₀: θ=0 против альтернативной гипотезы H₁: θ=1? Найти в явном виде критическое множество и вероятности ошибок α и β в случае выбора: a) c=1; б) c=5.
Решение:
Отношение правдоподобия:
λ(x) = f(x|θ=1) / f(x|θ=0) = [1/(π(1 + (x-1)²))] / [1/(π(1 + x²))] = (1 + x²) / (1 + (x-1)²)
Критическое множество C определяется как {x: λ(x) > c}, где c — константа.
(1 + x²) / (1 + (x-1)²) > c
1 + x² > c(1 + x² - 2x + 1)
1 + x² > c(x² - 2x + 2)
(1 - c)x² + 2cx + (1 - 2c) > 0
Разберем случаи:
a) c = 1:
(1 - 1)x² + 2 * 1 * x + (1 - 2 * 1) > 0
2x - 1 > 0
x > 1/2
Критическое множество C = (1/2, ∞)
Теперь найдем вероятности ошибок первого (α) и второго (β) рода:
•	α = P(X ∈ C | θ=0) = P(X > 1/2 | θ=0) = ∫₁/₂^∞ 1/(π(1 + x²)) dx = (1/π) * [arctan(x)]₁/₂^∞ = (1/π) * (π/2 - arctan(1/2)) ≈ (1/π) * (1.5708 - 0.4636) ≈ 0.352
•	β = P(X ∉ C | θ=1) = P(X ≤ 1/2 | θ=1) = ∫₋∞^½ 1/(π(1 + (x-1)²)) dx = (1/π) * [arctan(x-1)]₋∞^½ = (1/π) * (arctan(-1/2) - (-π/2)) = (1/π) * (-0.4636 + 1.5708) ≈ 0.352
б) c = 5:
(1 - 5)x² + 2 * 5 * x + (1 - 2 * 5) > 0
-4x² + 10x - 9 > 0
4x² - 10x + 9 < 0
Найдем дискриминант: D = (-10)² - 4 * 4 * 9 = 100 - 144 = -44. Так как дискриминант отрицательный, данное квадратное уравнение не имеет действительных корней. Поскольку коэффициент при x² отрицательный, неравенство 4x² - 10x + 9 < 0 не выполняется ни для каких действительных x.
Следовательно, критическое множество C пустое: C = ∅
Теперь найдем вероятности ошибок первого (α) и второго (β) рода:
•	α = P(X ∈ C | θ=0) = P(X ∈ ∅ | θ=0) = 0
•	β = P(X ∉ C | θ=1) = P(X ∈ R | θ=1) = 1
Итог:
•	a) c = 1: Критическое множество C = (1/2, ∞). α ≈ 0.352, β ≈ 0.352.
•	б) c = 5: Критическое множество C = ∅. α = 0, β = 1.
        """
    if var == 5:
        text = """4. Пусть Х₁, Х₂, ..., Хₙ - выборка из распределения Бернулли Bin(1, θ). Требуется найти методом максимального правдоподобия оценку θ.
Решение:
1.	Функция правдоподобия:
Распределение Бернулли описывается функцией вероятности:
P(X = x) = θ^x * (1 - θ)^(1 - x), где x принимает значения 0 или 1.
Для выборки X₁, X₂, ..., Xₙ функция правдоподобия имеет вид:
L(θ; x₁, ..., xₙ) = Πᵢ θ^xᵢ * (1 - θ)^(1 - xᵢ) = θ^(Σᵢ xᵢ) * (1 - θ)^(n - Σᵢ xᵢ)
2.	Логарифм функции правдоподобия:
Для упрощения нахождения максимума функции правдоподобия часто используют ее логарифм:
ln L(θ) = ln(θ^(Σᵢ xᵢ) * (1 - θ)^(n - Σᵢ xᵢ)) = (Σᵢ xᵢ)ln(θ) + (n - Σᵢ xᵢ)ln(1 - θ)
3.	Нахождение производной и приравнивание к нулю:
Чтобы найти максимум логарифма функции правдоподобия, возьмем производную по θ и приравняем ее к нулю:
d(ln L(θ))/dθ = (Σᵢ xᵢ)/θ - (n - Σᵢ xᵢ)/(1 - θ)
Приравниваем к нулю:
(Σᵢ xᵢ)/θ - (n - Σᵢ xᵢ)/(1 - θ) = 0
(Σᵢ xᵢ)(1 - θ) - θ(n - Σᵢ xᵢ) = 0
Σᵢ xᵢ - θΣᵢ xᵢ - nθ + θΣᵢ xᵢ = 0
Σᵢ xᵢ - nθ = 0
4.	Решение относительно θ:
nθ = Σᵢ xᵢ
θ̂ = (1/n) * Σᵢ xᵢ
Таким образом, оценка максимального правдоподобия для параметра θ в распределении Бернулли равна выборочному среднему:
θ̂ = x̄
Где x̄ - выборочное среднее.
Дополнительные пояснения:
•	Σᵢ xᵢ - это сумма всех значений выборки. В случае распределения Бернулли, это количество "успехов" (значений равных 1) в выборке.
•	n - размер выборки.
•	θ̂ - оценка параметра θ.
Этот результат интуитивно понятен: если мы провели n испытаний Бернулли и получили Σᵢ xᵢ "успехов", то наиболее вероятная оценка вероятности успеха θ - это отношение количества успехов к общему числу испытаний.
        """
    if var == 6:
        text = """4. Пусть x⃗ = (x₁, ..., x₃₀) - реализация случайной выборки X⃗ = (X₁, ..., X₃₀) из нормального распределения N(μ; σ²) (данные в файле ЭкзБ_6-4.csv). На уровне значимости α=0,05 основная гипотеза H₀: μ=1,76 против альтернативной гипотезы H₁: μ≠1,76.
1.	Найдите статистику критерия t=Tₙₐ₆ₗ=T(x⃗), критическое множество Kα и на 5% уровне значимости проверить основную гипотезу H₀.
2.	Найдите Р-значение критерия и сделайте выводы.
3.	Найдите вероятность ошибки второго рода β и мощность W критерия для μ=μ₁=1.66 и сделать выводы.
import numpy as np
import pandas as pd
import scipy.stats as st

try:
    data = pd.read_csv('ЭкзБ_6-4.csv')
    x = data['X'].values

    n = len(x)
    x_mean = np.mean(x)
    s = np.std(x, ddof=1)  # ddof=1 для выборочного стандартного отклонения

    mu0 = 1.76
    alpha = 0.05

    # 1) Статистика критерия и критическое множество
    t_stat = (x_mean - mu0) / (s / np.sqrt(n))
    t_crit = st.t.ppf(1 - alpha/2, n-1)
    print(f"Статистика критерия t: {t_stat:.4f}")
    print(f"Критическое значение t: ±{t_crit:.4f}")

    if abs(t_stat) > t_crit:
        print("Нулевая гипотеза H0 отвергается.")
    else:
        print("Нет оснований отвергать нулевую гипотезу H0.")

    # 2) P-значение
    p_value = 2 * (1 - st.t.cdf(abs(t_stat), n-1))
    print(f"P-значение: {p_value:.4f}")
    if p_value <= alpha:
        print("Нулевая гипотеза H0 отвергается (по p-значению).")
    else:
        print("Нет оснований отвергать нулевую гипотезу H0 (по p-значению).")

    # 3) Вероятность ошибки второго рода и мощность
    mu1 = 1.66
    beta = st.norm.cdf(t_crit + (mu0 - mu1) * np.sqrt(n) / s) - st.norm.cdf(-t_crit + (mu0 - mu1) * np.sqrt(n) / s)
    W = 1 - beta
    print(f"Вероятность ошибки второго рода β: {beta:.4f}")
    print(f"Мощность критерия W: {W:.4f}")

except FileNotFoundError:
    print("Ошибка: Файл ЭкзБ_6-4.csv не найден.")
except KeyError as e:
    print(f"Ошибка: столбец {e} не найден в файле.")
except Exception as e:
    print(f"Произошла ошибка: {e}")
        """
    if var == 7:
        text = """При 8002 независимых испытаний A, B и C, составляющие полную группу, осуществились 2014, 5008 и 980 раз соответственно. Верно ли на уровне значимости 0,05 гипотеза p(A)=0,5-2θ; p(B)=0,5+θ; p(C)=θ (0 < θ < 0,25)?
Решение:
1.	Вычислим эмпирические вероятности:
p̂(A) = 2014 / 8002 ≈ 0.252 p̂(B) = 5008 / 8002 ≈ 0.626 p̂(C) = 980 / 8002 ≈ 0.122
2.	Проверим, выполняется ли условие полной группы:
p̂(A) + p̂(B) + p̂(C) ≈ 0.252 + 0.626 + 0.122 = 1 (с учетом округлений). Условие выполняется.
3.	Сформулируем гипотезы:
H₀: p(A) = 0.5 - 2θ; p(B) = 0.5 + θ; p(C) = θ H₁: H₀ не верна
4.	Вычислим ожидаемые частоты при H₀. Для этого нужно найти θ.
Так как p(A) + p(B) + p(C) = 1, то (0.5 - 2θ) + (0.5 + θ) + θ = 1. Это условие выполняется тождественно и не помогает найти θ. Воспользуемся тем, что у нас есть эмпирические частоты.
Сложим p̂(B) и p̂(C): p̂(B) + p̂(C) = 0.626 + 0.122 = 0.748. С другой стороны, p(B) + p(C) = 0.5 + θ + θ = 0.5 + 2θ.
Приравняем: 0.5 + 2θ = 0.748 => 2θ = 0.248 => θ ≈ 0.124
Теперь найдем ожидаемые вероятности и частоты: p(A)=0,5 - 20.124=0.252, nA=0.2528002=2016 p(B)=0,5 + 0.124=0.624, nB=0.6248002=4993 p(C)=0.124, nC=0.1248002=992
5.	Статистика χ²:
χ² = Σᵢ ((nᵢ - Eᵢ)² / Eᵢ) = ((2014-2016)^2/2016)+((5008-4993)^2/4993)+((980-992)^2/992) ≈ 0.002 + 0.045 + 0.145 ≈ 0.192
6.	Критическое значение:
Степени свободы: k - 1 = 3 - 1 = 2 (где k - количество категорий).
χ²₀.₀₅(2) ≈ 5.991
7.	Сравнение и вывод:
χ² ≈ 0.192 < 5.991. Следовательно, на уровне значимости 0.05 нет оснований отвергать гипотезу H₀. Гипотеза о заданных вероятностях p(A), p(B) и p(C) не противоречит эмпирическим данным.
        """
    if var == 8:
        text = """По трем независимым выборкам, объемы которых n₁=10, n₂=14 и n₃=17, извлеченным из нормальных генеральных совокупностей, найдены исправленные выборочные дисперсии, соответственно равные 3,6; 3,3 и 7,2. Требуется: 1) на уровне значимости 0,06 проверить нулевую гипотезу о равенстве дисперсий; 2) оценить генеральную дисперсию.
Поскольку у нас три выборки, прямое применение F-критерия невозможно. В данном случае, более подходящим является критерий Бартлетта.
1.	Критерий Бартлетта:
o	Гипотезы:
	H₀: σ₁² = σ₂² = σ₃² (дисперсии равны)
	H₁: хотя бы одна дисперсия отличается
o	Статистика критерия:
χ² = (N - k) * ln(s²_pooled) - Σᵢ (nᵢ - 1) * ln(sᵢ²)
где:
	N = n₁ + n₂ + n₃ = 10 + 14 + 17 = 41 - общий размер выборок
	k = 3 - количество выборок
	sᵢ² - исправленная выборочная дисперсия i-й выборки
	s²_pooled - объединенная выборочная дисперсия:
s²_pooled = (Σᵢ (nᵢ - 1)sᵢ²) / (N - k) = ((10-1)3.6 + (14-1)3.3 + (17-1)7.2)/(41-3) = (93.6+133.3+167.2)/38 = (32.4 + 42.9+115.2)/38 = 190.5/38 ≈ 5.01
o	Вычисляем статистику критерия:
χ² = (41 - 3) * ln(5.01) - (9 * ln(3.6) + 13 * ln(3.3) + 16 * ln(7.2)) χ² ≈ 38 * 1.611 - (9 * 1.281 + 13 * 1.194 + 16 * 1.974) ≈ 61.218 - (11.529+15.522+31.584) ≈ 61.218 - 58.635 ≈ 2.583
o	Критическое значение:
Критическое значение χ²(α, k-1) для α = 0.06 и k - 1 = 2 степенях свободы: χ²₀.₀₆(2) ≈ 5.64
o	Сравнение и вывод:
χ² ≈ 2.583 < 5.64. Следовательно, на уровне значимости 0.06 нет оснований отвергать нулевую гипотезу о равенстве дисперсий.
2.	Оценка генеральной дисперсии:
В случае, если гипотеза о равенстве дисперсий не отвергается (как в нашем случае), наилучшей оценкой генеральной дисперсии является объединенная выборочная дисперсия:
s²_pooled ≈ 5.01
        """
    if var == 9:
        text = """Известно, что доля возврата по кредитам имеет распределение F(x)=x^β, 0≤x≤1. Наблюдения показали, что в среднем она составляет 85%. Методом моментов оцените параметр β и вероятность того, что она опустится ниже 65%.
Решение:
1.	Найдем математическое ожидание распределения: E(X) = ∫₀¹ x * βx^(β-1) dx = β∫₀¹ x^β dx = β * [x^(β+1)/(β+1)]₀¹ = β/(β+1)
2.	Приравняем математическое ожидание к выборочному среднему (0.85): β/(β+1) = 0.85 β = 0.85β + 0.85 0.15β = 0.85 β = 0.85 / 0.15 ≈ 5.67
3.	Найдем вероятность того, что доля возврата опустится ниже 65%: P(X < 0.65) = ∫₀^(0.65) βx^(β-1) dx = [x^β]₀^(0.65) = (0.65)^5.67 ≈ 0.076
        """
    if var == 10:
        text = """Инвестор имеет данные по доходности актива А за 5 лет, актива Б за 7 лет, актива В - за 10 лет. Исправленные выборочные дисперсии доходностей равны 0,01; 0,02 и 0,03 соответственно. Можно ли утверждать на уровне значимости 5%, что риск вложений в эти активы одинаков?
Решение:
Для проверки равенства дисперсий трех и более выборок используется критерий Бартлетта.
1.	Формулируем гипотезы:
o	H₀: σ₁² = σ₂² = σ₃² (дисперсии доходностей активов А, Б и В равны)
o	H₁: хотя бы одна дисперсия отличается
2.	Вычисляем статистику критерия Бартлетта:
χ² = (N - k) * ln(s²_pooled) - Σᵢ (nᵢ - 1) * ln(sᵢ²)
где:
o	N = n₁ + n₂ + n₃ = 5 + 7 + 10 = 22 - общий размер выборки
o	k = 3 - количество активов (выборок)
o	nᵢ - размер i-й выборки
o	sᵢ² - исправленная выборочная дисперсия i-й выборки
o	s²_pooled - объединенная выборочная дисперсия:
s²_pooled = (Σᵢ (nᵢ - 1)sᵢ²) / (N - k)
Подставим значения:
s²_pooled = ((5 - 1) * 0.01 + (7 - 1) * 0.02 + (10 - 1) * 0.03) / (22 - 3) s²_pooled = (4 * 0.01 + 6 * 0.02 + 9 * 0.03) / 19 s²_pooled = (0.04 + 0.12 + 0.27) / 19 s²_pooled = 0.43 / 19 ≈ 0.0226
Теперь вычислим статистику χ²:
χ² = (22 - 3) * ln(0.0226) - (4 * ln(0.01) + 6 * ln(0.02) + 9 * ln(0.03)) χ² = 19 * (-3.791) - (4 * (-4.605) + 6 * (-3.912) + 9 * (-3.507)) χ² ≈ -72.029 - (-18.42 - 23.472 - 31.563) χ² ≈ -72.029 + 73.455 χ² ≈ 1.426
3.	Определяем число степеней свободы:
df = k - 1 = 3 - 1 = 2
4.	Находим критическое значение χ²:
Для уровня значимости α = 0.05 и 2 степеней свободы, критическое значение χ²₀.₀₅(2) ≈ 5.991 (можно найти в таблице распределения хи-квадрат или с помощью статистического калькулятора).
5.	Сравниваем вычисленное значение χ² с критическим:
χ² ≈ 1.426 < χ²₀.₀₅(2) ≈ 5.991
6.	Вывод:
Поскольку вычисленное значение статистики критерия Бартлетта (1.426) меньше критического значения (5.991), у нас нет оснований отвергать нулевую гипотезу H₀ на уровне значимости 5%. Это означает, что мы не можем утверждать, что риск вложений в эти активы различается статистически значимо.
        """
    if var == 11:
        text = """Пусть x⃗ =(x₁, ..., x₂₅) реализация случайной выборки X⃗ =(X₁, ..., X₂₅) из нормального распределения N(μₓ;0,7²), а y⃗ =(y₁, ..., y₃₀) реализация случайной выборки Y⃗ =(Y₁, ..., Y₃₀) из нормального N(μᵧ;1,1²). Известно, что x⃗ и y⃗ независимы. Проверяется гипотеза H₀: μₓ=μᵧ против альтернативной гипотезы H₁: μₓ<μᵧ. При уровне значимости α применяется критерий с критической областью {Z<A}, где статистика критерия Z=Z(X⃗,Y⃗) это нормированная разность X̄-Ȳ, A=Aα зависящее от α критическое значение. Соответствующее критическое множество имеет вид Kα=(Aα;∞). 1) Найдите значение статистики критерия Zнабл.=Z(x⃗,y⃗). 2) Найдите Р-значение критерия. 3) Найдите критическое значение A, критическое множество Kα и проверьте гипотезу H₀ при α=0,01. 4) Найдите мощность критерия W в случае μₓ-μᵧ=-0,3 и α=0,01. Исходные данные в файле ЭкзБ_11-4.csv.
Решение:
1.	Статистика критерия Z:
Z = (X̄ - Ȳ) / √(σₓ²/n₁ + σᵧ²/n₂) = (X̄ - Ȳ) / √(0.7²/25 + 1.1²/30) = (X̄ - Ȳ) / √(0.0196 + 0.0403) = (X̄ - Ȳ) / √0.0599 ≈ (X̄ - Ȳ) / 0.245
Для вычисления Zнабл. необходимо загрузить данные из файла ЭкзБ_11-4.csv, вычислить выборочные средние x̄ и ȳ, и подставить их в формулу.
Пример (предположим, после загрузки данных x̄=1.5 и ȳ=1.9): Zнабл. = (1.5 - 1.9) / 0.245 ≈ -1.63
2.	P-значение:
Так как альтернативная гипотеза H₁: μₓ < μᵧ (левосторонняя), P-значение равно:
P-значение = P(Z < Zнабл.)
Для Zнабл. ≈ -1.63, P-значение ≈ 0.0516 (по таблице стандартного нормального распределения или с помощью калькулятора).
3.	Критическое значение A, критическое множество Kα и проверка гипотезы H₀ при α=0,01:
Для α = 0.01 и левосторонней альтернативы, критическое значение A = z₀.₀₁ ≈ -2.33 (по таблице стандартного нормального распределения).
Критическое множество Kα = (-∞; -2.33).
Проверка гипотезы:
o	Если Zнабл. < -2.33, то H₀ отвергается.
o	Если Zнабл. ≥ -2.33, то нет оснований отвергать H₀.
В нашем примере (Zнабл. ≈ -1.63): -1.63 > -2.33, поэтому H₀ не отвергается на уровне значимости 0.01.
4.	Мощность критерия W в случае μₓ - μᵧ = -0.3 и α = 0.01:
Мощность критерия W = P(отвергнуть H₀ | H₁ верна).
Z = (X̄ - Ȳ) / √(σₓ²/n₁ + σᵧ²/n₂)
При H₁: μₓ - μᵧ = -0.3
P(Z < -2.33 | μₓ - μᵧ = -0.3) = P(((X̄ - Ȳ) - (-0.3)) / √(0.7²/25 + 1.1²/30) < (-2.33√(0.7²/25 + 1.1²/30)-0.3)/√(0.7²/25 + 1.1²/30)) P(Z < -2.33 | μₓ - μᵧ = -0.3) = P(Z < (-2.330.245 - 0.3)/0.245) ≈ P(Z < -3.55)
W = P(Z < -3.55) ≈ 0.0002
Мощность критерия очень мала, что означает низкую вероятность обнаружить разницу между средними, равную -0.3, при заданном уровне значимости и объемах выборок.
Для получения точных численных результатов необходимо загрузить данные из файла ЭкзБ_11-4.csv и выполнить соответствующие расчеты. Приведенные выше примеры с Zнабл. ≈ -1.63 и мощностью 0.0002 являются иллюстративными.
        """
    if var == 12:
        text = """По содержащейся в файле ЭкзБ_12-4.csv реализации выборки из двумерного нормального распределения N((E(X); E(Y)); (Var(X) Cov(X,Y); Cov(X,Y) Var(Y))) = N((0;0); (σ² ρσ; ρσ σ²)) с неизвестными параметрами θ₁ = σ² > 0 и θ₂ = ρ ∈ (-1; 1) запишите логарифм функции правдоподобия L(ρ, σ) и вычислите оценки максимального правдоподобия неизвестных параметров σ² и ρ.
Решение:
1.	Плотность двумерного нормального распределения (с μₓ = μᵧ = 0 и σₓ² = σᵧ² = σ²):
f(x, y; σ², ρ) = (1/(2πσ²√(1-ρ²))) * exp{-[x² - 2ρxy + y²]/(2σ²(1-ρ²))}
2.	Функция правдоподобия для выборки (x₁, y₁), (x₂, y₂), ..., (xₙ, yₙ):
L(σ², ρ) = Πᵢ f(xᵢ, yᵢ; σ², ρ) = (1/(2πσ²√(1-ρ²)))ⁿ * exp{-(1/(2σ²(1-ρ²))) * Σᵢ [xᵢ² - 2ρxᵢyᵢ + yᵢ²]}
3.	Логарифм функции правдоподобия:
ln L(σ², ρ) = -n ln(2π) - n ln(σ²) - (n/2) ln(1-ρ²) - (1/(2σ²(1-ρ²))) * Σᵢ [xᵢ² - 2ρxᵢyᵢ + yᵢ²]
4.	Находим частные производные по σ² и ρ и приравниваем их к нулю:
o	Производная по σ²:
∂(ln L)/∂(σ²) = -n/σ² + (1/(2(σ²)²(1-ρ²))) * Σᵢ [xᵢ² - 2ρxᵢyᵢ + yᵢ²] = 0
Отсюда:
σ̂² = (1/(2n(1-ρ²))) * Σᵢ [xᵢ² - 2ρxᵢyᵢ + yᵢ²]
o	Производная по ρ:
∂(ln L)/∂ρ = (nρ/(1-ρ²)) + (1/(2σ²(1-ρ²)²)) * Σᵢ [xᵢ² - 2ρxᵢyᵢ + yᵢ²] * 2ρ - (1/(2σ²(1-ρ²)²)) * Σᵢ -2xᵢyᵢ = 0
После упрощений:
ρ̂ = (Σᵢ xᵢyᵢ) / (Σᵢ (xᵢ² + yᵢ²))
5.	Подстановка ρ̂ в выражение для σ̂²:
6.	σ̂² = (1/(2n)) * Σᵢ [xᵢ² - 2 * ((Σᵢ xᵢyᵢ) / (Σᵢ (xᵢ² + yᵢ²))) * xᵢyᵢ + yᵢ²]
7.	σ̂² = (1/(2n)) * Σᵢ [xᵢ² + yᵢ²] - (1/n) * ((Σᵢ xᵢyᵢ)² / (Σᵢ (xᵢ² + yᵢ²)))
8.	
9.	Или, чаще используемая форма:
10.	σ̂² = (1/n) * Σᵢ (xᵢ² + yᵢ² - 2ρ̂xᵢyᵢ)
Окончательные оценки максимального правдоподобия:
•	ρ̂ = (Σᵢ xᵢyᵢ) / (Σᵢ (xᵢ² + yᵢ²))
•	σ̂² = (1/n) * Σᵢ (xᵢ² + yᵢ² - 2ρ̂xᵢyᵢ)
        """
    if var == 13:
        text = """Для случайно величины с распределением X 0; 1; 2; 3; 4 
P 0,2; 0,1 - θ; 0,5 + θ; 0,2 получена выборка: 1, 1, 4, 4, 2, 0, 1, 1. Получить оценку методом наибольшего правдоподобия параметра θ. 
Давайте найдем оценку параметра θ методом наибольшего правдоподобия для заданной случайной величины и выборки.
1. Запишем функцию правдоподобия:
Функция правдоподобия L(θ) – это совместная вероятность получения наблюдаемой выборки при заданном значении параметра θ. Поскольку наблюдения независимы, функция правдоподобия равна произведению вероятностей каждого наблюдения:
L(θ) = Пᵢ P(X = xᵢ)
В нашем случае выборка: 1, 1, 4, 4, 2, 0, 1, 1. Значит:
L(θ) = P(X=1) * P(X=1) * P(X=4) * P(X=4) * P(X=2) * P(X=0) * P(X=1) * P(X=1)
Используя заданные вероятности:
L(θ) = (0.1 - θ) * (0.1 - θ) * 0.2 * 0.2 * (0.5 + θ) * 0.2 * (0.1 - θ) * (0.1 - θ)
L(θ) = 0.0016 * (0.1 - θ)⁴ * (0.5 + θ)
2. Найдем логарифм функции правдоподобия:
Взятие логарифма упрощает задачу нахождения максимума, так как логарифмическая функция монотонно возрастает.
ln L(θ) = ln(0.0016) + 4 ln(0.1 - θ) + ln(0.5 + θ)
3. Найдем производную логарифма функции правдоподобия по θ и приравняем ее к нулю:
d(ln L(θ))/dθ = -4/(0.1 - θ) + 1/(0.5 + θ) = 0
4. Решим полученное уравнение:
-4(0.5 + θ) + (0.1 - θ) = 0 -2 - 4θ + 0.1 - θ = 0 -1.9 - 5θ = 0 -5θ = 1.9 θ = -0.38
5. Проверим, попадает ли полученное значение в допустимый интервал для θ:
По условию задачи, вероятности должны быть неотрицательными:
•	P(X=1) = 0.1 - θ ≥ 0 => θ ≤ 0.1
•	P(X=2) = 0.5 + θ ≥ 0 => θ ≥ -0.5
Полученное значение θ = -0.38 удовлетворяет обоим условиям (-0.5 ≤ θ ≤ 0.1).
6. Проверим, является ли это максимум (вторая производная):
d²(ln L(θ))/dθ² = -4/(0.1-θ)² - 1/(0.5+θ)²
При θ = -0.38 вторая производная будет отрицательной, что подтверждает, что это максимум.
Ответ: Оценка параметра θ методом наибольшего правдоподобия равна -0.38.
        """
    if var == 14:
        text = """Сравниваются четыре способа обработки изделий. Лучшим считается тот из способов, дисперсия контролируемого параметра которого меньше. Первым способом обработано 15, вторым — 20, третьим — 20, четвертым — 14 изделий. Исправленные выборочные дисперсии 1 sᵢ² соответственно равны: 0,00053; 0,00078; 0,00096; 0,00062. Можно ли отдать предпочтение одному из способов при уровне значимости 0,05? Предполагается, что контролируемый параметр распределен нормально. 
Решение:
Для сравнения дисперсий нескольких нормальных выборок используется критерий Бартлетта.
1.	Формулируем гипотезы:
o	H₀: σ₁² = σ₂² = σ₃² = σ₄² (дисперсии всех способов обработки равны)
o	H₁: хотя бы одна дисперсия отличается
2.	Вычисляем статистику критерия Бартлетта:
χ² = (N - k) * ln(s²_pooled) - Σᵢ (nᵢ - 1) * ln(sᵢ²)
где:
o	N = n₁ + n₂ + n₃ + n₄ = 15 + 20 + 20 + 14 = 69 - общий размер выборки
o	k = 4 - количество способов обработки (выборок)
o	nᵢ - размер i-й выборки
o	sᵢ² - исправленная выборочная дисперсия i-й выборки
o	s²_pooled - объединенная выборочная дисперсия:
s²_pooled = (Σᵢ (nᵢ - 1)sᵢ²) / (N - k)
Подставим значения:
s²_pooled = ((15-1)0.00053 + (20-1)0.00078 + (20-1)0.00096 + (14-1)0.00062) / (69-4) s²_pooled = (140.00053 + 190.00078 + 190.00096 + 130.00062) / 65 s²_pooled = (0.00742 + 0.01482 + 0.01824 + 0.00806) / 65 s²_pooled = 0.04854 / 65 ≈ 0.000747
Теперь вычислим статистику χ²:
χ² = (69 - 4) * ln(0.000747) - (14 * ln(0.00053) + 19 * ln(0.00078) + 19 * ln(0.00096) + 13 * ln(0.00062)) χ² = 65 * (-7.20) - (14 * (-7.54) + 19 * (-7.16) + 19 * (-6.95) + 13 * (-7.39)) χ² ≈ -468 - (-105.56 - 136.04 - 132.05 - 96.07) χ² ≈ -468 + 469.72 χ² ≈ 1.72
3.	Определяем число степеней свободы:
df = k - 1 = 4 - 1 = 3
4.	Находим критическое значение χ²:
Для уровня значимости α = 0.05 и 3 степеней свободы, критическое значение χ²₀.₀₅(3) ≈ 7.815 (можно найти в таблице распределения хи-квадрат).
5.	Сравниваем вычисленное значение χ² с критическим:
χ² ≈ 1.72 < χ²₀.₀₅(3) ≈ 7.815
6.	Вывод:
Поскольку вычисленное значение статистики критерия Бартлетта (1.72) меньше критического значения (7.815), у нас нет оснований отвергать нулевую гипотезу H₀ на уровне значимости 0.05. Это означает, что мы не можем утверждать, что дисперсии способов обработки изделий различаются статистически значимо.
Ответ: На уровне значимости 0.05 нельзя отдать предпочтение одному из способов обработки изделий на основании имеющихся данных о дисперсиях. Различия в выборочных дисперсиях не являются статистически значимыми.
        """
    if var == 15:
        text = """Дана выборка из распределения Лапласа с плотностью f(x) = (1/2)e^(-|x-θ|). Найдите оценку параметра θ методом максимального правдоподобия.
Решение:
Функция правдоподобия для выборки x₁, ..., xₙ:
L(θ) = Πᵢ (1/2)e^(-|xᵢ-θ|) = (1/2ⁿ) * exp(-Σᵢ |xᵢ-θ|)
Логарифм функции правдоподобия:
ln L(θ) = -n ln(2) - Σᵢ |xᵢ-θ|
Для максимизации ln L(θ) необходимо минимизировать функцию:
g(θ) = Σᵢ |xᵢ-θ|
Известно, что сумма модулей отклонений от некоторой точки минимальна, когда эта точка является медианой выборки.
Конкретные формулы для ответа:
Пусть x₁ ≤ x₂ ≤ ... ≤ xₙ — упорядоченная выборка.
•	Если n — нечетное, то медиана (и, следовательно, оценка θ методом максимального правдоподобия) равна:
θ̂ = x_((n+1)/2)
•	Если n — четное, то медиана (и оценка θ) равна:
θ̂ = (x_(n/2) + x_((n/2)+1)) / 2
Пример:
Пусть дана выборка: 2, 5, 1, 8, 3. n = 5 (нечетное). Упорядоченная выборка: 1, 2, 3, 5, 8.
θ̂ = x_((5+1)/2) = x₃ = 3
Если бы выборка была 2, 5, 1, 8, n = 4 (четное). Упорядоченная выборка: 1, 2, 5, 8
θ̂ = (x_(4/2) + x_((4/2)+1)) / 2 = (x₂ + x₃) / 2 = (2+5)/2 = 3.5
Ответ: Оценка параметра θ методом максимального правдоподобия — медиана выборки. Формулы для вычисления медианы зависят от четности размера выборки и приведены выше.
        """
    if var == 16:
        text = """Пусть X₁, ..., Xₙ — выборка объема n из распределения Пуассона с параметром λ: P(X=k) = (λᵏe⁻λ)/k!, k=0,1,2,... Найдите методом наибольшего правдоподобия по выборке x₁, ..., xₙ точечную оценку неизвестного параметра λ распределения Пуассона.
Решение:
1.	Функция правдоподобия:
L(λ; x₁, ..., xₙ) = Πᵢ (λ^(xᵢ) * e⁻λ) / xᵢ! = (λ^(Σxᵢ) * e^(-nλ)) / Πᵢ xᵢ!
2.	Логарифм функции правдоподобия:
ln L(λ) = (Σxᵢ) * ln(λ) - nλ - Σ ln(xᵢ!)
3.	Производная логарифма функции правдоподобия по λ:
d(ln L(λ))/dλ = (Σxᵢ)/λ - n = 0
4.	Решение уравнения:
(Σxᵢ)/λ = n λ̂ = (Σxᵢ)/n = X̄
Ответ: Оценка параметра λ методом наибольшего правдоподобия равна выборочному среднему X̄.
        """
    if var == 17:
        text = """Доказать формулу для вычисления информации по Фишеру для одного наблюдения (случайной величины) X:
I(θ) = Eθ([∂ ln f(X; θ)/∂θ]²) = -Eθ(∂² ln f(X; θ)/∂θ²),
где f(x,θ) - плотность распределения. Для дискретной случайной величины вместо f(x,θ) используется закон распределения Pθ(X=x).
Доказательство:
Начнем с определения информации Фишера:
I(θ) = Eθ([∂ ln f(X; θ)/∂θ]²)
Предположим, что можно дифференцировать под знаком интеграла (или суммы для дискретного случая):
∫ f(x; θ) dx = 1
Дифференцируем обе части по θ:
∫ [∂ f(x; θ)/∂θ] dx = 0
Разделим и умножим подинтегральное выражение на f(x; θ):
∫ [∂ f(x; θ)/∂θ] * [f(x; θ) / f(x; θ)] dx = 0 ∫ [∂ ln f(x; θ)/∂θ] * f(x; θ) dx = 0
Это можно записать как:
Eθ[∂ ln f(X; θ)/∂θ] = 0
Теперь дифференцируем это выражение еще раз по θ:
∫ [∂² ln f(x; θ)/∂θ² * f(x; θ) + (∂ ln f(x; θ)/∂θ)² * f(x; θ)] dx = 0
Разделим это на два интеграла:
∫ [∂² ln f(x; θ)/∂θ²] * f(x; θ) dx + ∫ (∂ ln f(x; θ)/∂θ)² * f(x; θ) dx = 0
Перепишем это в терминах математического ожидания:
Eθ[∂² ln f(X; θ)/∂θ²] + Eθ[(∂ ln f(X; θ)/∂θ)²] = 0
Теперь перенесем первое слагаемое в правую часть:
Eθ[(∂ ln f(X; θ)/∂θ)²] = -Eθ[∂² ln f(X; θ)/∂θ²]
Левая часть этого равенства по определению является информацией Фишера I(θ):
I(θ) = Eθ([∂ ln f(X; θ)/∂θ]²)
Таким образом, мы доказали, что:
I(θ) = Eθ([∂ ln f(X; θ)/∂θ]²) = -Eθ[∂² ln f(X; θ)/∂θ²]
Что это значит и почему это важно:
•	Информация Фишера – это мера количества информации, которую случайная величина X несет о неизвестном параметре θ, от которого зависит ее распределение.
•	Формула показывает, что информацию Фишера можно вычислить двумя способами: либо как математическое ожидание квадрата первой производной логарифма функции правдоподобия, либо как математическое ожидание взятое с противоположным знаком второй производной логарифма функции правдоподобия.
•	На практике часто бывает проще вычислить вторую производную, чем квадрат первой, поэтому вторая форма записи оказывается более удобной.
•	Информация Фишера играет важную роль в статистическом выводе, в частности, при оценке параметров (например, при использовании границы Рао-Крамера для нахождения минимальной дисперсии несмещенной оценки).
Для дискретного случая:
В случае дискретной случайной величины X, вместо плотности вероятности f(x; θ) используется функция вероятности Pθ(X=x). Все рассуждения остаются аналогичными, только интегралы заменяются на суммы:
I(θ) = Eθ([∂ ln Pθ(X)/∂θ]²) = -Eθ[∂² ln Pθ(X)/∂θ²]
где:
•	∂ ln Pθ(X)/∂θ – первая производная логарифма функции вероятности по θ.
•	∂² ln Pθ(X)/∂θ² – вторая производная логарифма функции вероятности по θ.
•	Eθ – математическое ожидание, вычисленное при заданном значении θ.
Теперь доказательство завершено полностью для обоих случаев (непрерывного и дискретного).
        """
    if var == 18:
        text = """Средний вес таблетки сильнодействующего лекарства (номинал) должен быть равен 0,5 мг. Выборочная проверка n=100 выпущенных таблеток показала, что средний вес таблетки равен 0,508 мг. Многократными предварительными опытами по взвешиванию таблеток, изготавливаемых фармацевтическим заводом, установлено, что вес таблеток распределен нормально со средним квадратическим отклонением 1 σ=0,11 мг. Требуется на уровне значимости α=0,1 проверить гипотезу о том, что средний вес таблеток действительно равен H₀: μ = 0,5. Найдите вероятность ошибки второго рода β и мощность W критерия для μ=μ₁=0,7 и сделать выводы. 
Решение:
1.	Формулируем гипотезы:
o	H₀: μ = 0,5
o	H₁: μ ≠ 0,5 (двусторонняя гипотеза)
2.	Статистика критерия: Так как σ известно, используем z-критерий:
z = (X̄ - μ₀) / (σ/√n) = (0.508 - 0.5) / (0.11/√100) = 0.008 / 0.011 ≈ 0.73
3.	Критическая область: Для α = 0.1 и двусторонней гипотезы, z_α/2 = z₀.₀₅ ≈ 1.645 (из таблицы стандартного нормального распределения).
Критическая область: |z| > 1.645
4.	Принятие решения: Так как |0.73| < 1.645, мы не отвергаем нулевую гипотезу.
5.	Вероятность ошибки второго рода β и мощность критерия W при μ₁=0,7:
β = P(не отвергнуть H₀ | H₁ верна) = P(|z| < 1.645 | μ = 0.7)
z = (X̄ - μ₁) / (σ/√n)
Пересчитаем критические значения для μ = 0.7:
-1.645 = (X̄₁ - 0.7) / (0.11/√100) => X̄₁ = 0.7 - 1.645 * 0.011 ≈ 0.6819 1.645 = (X̄₂ - 0.7) / (0.11/√100) => X̄₂ = 0.7 + 1.645 * 0.011 ≈ 0.7181
β = P(0.6819 < X̄ < 0.7181 | μ = 0.7) = P((0.6819 - 0.7)/(0.11/√100) < z < (0.7181 - 0.7)/(0.11/√100)) β = P(-1.645 < z < 1.645) ≈ 0.90 W = 1-β = 1 - 0.90 = 0.10
Выводы:
•	На уровне значимости 0.1 нет оснований отвергать гипотезу о том, что средний вес таблетки равен 0.5 мг.
•	Вероятность ошибки второго рода при μ=0.7 составляет приблизительно 0.90. Это означает, что с вероятностью 90% мы не обнаружим отклонение среднего веса от 0.5 мг, если на самом деле он равен 0.7 мг.
•	Мощность критерия при μ=0.7 составляет 0.10. Это означает, что с вероятностью 10% мы обнаружим отклонение среднего веса от 0.5 мг, если на самом деле он равен 0.7 мг. Мощность критерия очень низкая, что говорит о низкой способности критерия обнаружить реальное отклонение. Это связано с относительно небольшим размером выборки и небольшим различием между μ₀ и μ₁.
        """
    if var == 19:
        text = """Пусть x⃗ = (x₁, ..., x₃₀) — реализация случайной выборки X⃗ = (X₁, ..., X₃₀) из нормального распределения N(μ; σ²). Проверяется на уровне значимости α=0,02 гипотеза H₀: σ=1,17 против альтернативной гипотезы H₁: σ≠1,17. Исходные данные в файле ЭкзБ_19-4.csv. 1) Найдите значение χ² статистики. 2) Найдите границы A и B критического множества и проверьте гипотезу H₀. 3) Найдите P-значение критерия. 4) Найдите вероятность ошибки второго рода β для σ₁ = 1,21.
Решение:
import pandas as pd
import numpy as np
from scipy.stats import chi2

try:
    data = pd.read_csv("ЭкзБ_19-4.csv", header=None, names=['Значение'])
    sample = data['Значение'].values
    n = len(sample)
    s_squared = np.var(sample, ddof=1)  # ddof=1 для несмещенной выборочной дисперсии
    print(f"Выборочная дисперсия (s²): {s_squared}")
    chi_squared = (n - 1) * s_squared / (1.17**2)
    print(f"Значение статистики χ²: {chi_squared}")

    #2) Критические значения
    alpha = 0.02
    critical_value_left = chi2.ppf(alpha/2, n-1)
    critical_value_right = chi2.ppf(1-alpha/2, n-1)
    print(f"Критическая область: ({critical_value_left}, {critical_value_right})")

    if chi_squared < critical_value_left or chi_squared > critical_value_right:
        print("Нулевая гипотеза отвергается")
    else:
        print("Нулевая гипотеза не отвергается")

    #3) P-значение
    p_value = 2 * min(chi2.cdf(chi_squared, n - 1), 1 - chi2.cdf(chi_squared, n - 1))
    print(f"P-значение: {p_value}")

    #4) Вероятность ошибки второго рода
    sigma1 = 1.21
    beta = chi2.cdf((1.17**2 * critical_value_right)/(sigma1**2) , n-1) - chi2.cdf((1.17**2 * critical_value_left)/(sigma1**2), n-1)
    print(f"Вероятность ошибки второго рода (β) при σ₁ = 1.21: {beta}")
    power = 1-beta
    print(f"Мощность критерия (1-β) при σ₁ = 1.21: {power}")

except FileNotFoundError:
    print("Файл ЭкзБ_19-4.csv не найден.")
except Exception as e:
    print(f"Произошла ошибка: {e}")
        """
    if var == 20:
        text = """Устройство состоит из элементов, время безотказной работы которых подчинено гамма-распределению:
f(x) = (1/(β^(α+1)Γ(α+1))) * x^α * e^(-x/β) (α > -1, β > 0, x ≥ 0); E(X) = (α+1)β; Var(X) = (α+1)β².
Испытания четырёх элементов дали следующие наработки (время работы элемента в часах до отказа): 42, 41, 113, 120. Найти методом моментов точечные оценки неизвестных параметров α и β, которыми определяется гамма-распределение.
Решение:
1.	Вычисляем выборочное среднее (X̄) и выборочную дисперсию (s²):
X̄ = (42 + 41 + 113 + 120) / 4 = 316 / 4 = 79
s² = Σ(xᵢ - X̄)² / (n - 1) = [(42-79)² + (41-79)² + (113-79)² + (120-79)²] / 3 = [1369 + 1444 + 1156 + 1681] / 3 = 5650/3 ≈ 1883.33
2.	Приравниваем теоретические моменты к выборочным:
E(X) = (α + 1)β = X̄ = 79 Var(X) = (α + 1)β² = s² = 1883.33
3.	Решаем систему уравнений:
Из первого уравнения выразим α:
α = (79/β) - 1
Подставим это во второе уравнение:
((79/β) - 1 + 1)β² = 1883.33 79β = 1883.33 β ≈ 23.84
Теперь найдем α:
α = (79/23.84) - 1 ≈ 3.31 - 1 ≈ 2.31
Ответ: Оценки методом моментов: α ≈ 2.31, β ≈ 23.84.
        """
    if var == 21:
        text = """Случайная величина Х – ошибка измерения дальности радиодальномером – имеет равномерное распределение на [а; b], где а, b – неизвестные параметры. Эмпирическое распределение ошибки n=60 независимых измерений имеет вид:
| xᵢ | 2 | 4 | 7 | 8 |
| nᵢ | 17 | 14 | 12 | 17 |
Найти методом моментов значения точечных оценок неизвестных параметров а, b.
Решение:
1.	Вычисляем выборочное среднее (X̄):
X̄ = (217 + 414 + 712 + 817) / 60 = (34 + 56 + 84 + 136) / 60 = 310 / 60 ≈ 5.17
2.	Вычисляем выборочный второй момент (E(X²)):
E(X²) = (2²17 + 4²14 + 7²12 + 8²17) / 60 = (68 + 224 + 588 + 1088) / 60 = 1968/60 = 32.8
3.	Теоретические моменты для равномерного распределения на [a, b]:
E(X) = (a + b) / 2 E(X²) = (a² + ab + b²) / 3
4.	Приравниваем теоретические моменты к выборочным:
1.	(a + b) / 2 = X̄ ≈ 5.17
2.	(a² + ab + b²) / 3 = E(X²) = 32.8
Из первого уравнения выразим b:
b = 2 * 5.17 - a = 10.34 - a
Подставим это выражение во второе уравнение:
(a² + a(10.34 - a) + (10.34 - a)²) / 3 = 32.8 (a² + 10.34a - a² + 106.92 - 20.68a + a²) / 3 = 32.8 (a² - 10.34a + 106.92) / 3 = 32.8 a² - 10.34a + 106.92 = 98.4 a² - 10.34a + 8.52 = 0
Решаем квадратное уравнение для a:
D = b² - 4ac = (-10.34)² - 4 * 1 * 8.52 = 106.92 - 34.08 = 72.84 √D ≈ 8.53
a₁ = (10.34 + 8.53) / 2 ≈ 9.435 a₂ = (10.34 - 8.53) / 2 ≈ 0.905
Теперь найдем соответствующие значения b:
b₁ = 10.34 - 9.435 ≈ 0.905 b₂ = 10.34 - 0.905 ≈ 9.435
Поскольку по определению равномерного распределения a < b, получаем:
a ≈ 0.905 b ≈ 9.435
Ответ: Оценки методом моментов: â ≈ 0.905, b̂ ≈ 9.435
        """
    if var == 22:
        text = """Случайная величина Х распределена по закону P({X=k}) = θ(1-θ)ᵏ, k=0,1,2,..., где θ – неизвестный параметр, 0<θ<1. В результате трёх измерений величина Х приняла значения 0, 1 и 3. Найдите оценку θ̂ параметра θ̂ методом максимального правдоподобия.
Решение:
1.	Функция правдоподобия:
L(θ; x₁, x₂, x₃) = θ(1-θ)⁰ * θ(1-θ)¹ * θ(1-θ)³ = θ³(1-θ)⁴
2.	Логарифм функции правдоподобия:
ln L(θ) = 3 ln(θ) + 4 ln(1-θ)
3.	Производная логарифма функции правдоподобия по θ:
d(ln L(θ))/dθ = 3/θ - 4/(1-θ)
4.	Приравниваем производную к нулю и решаем уравнение:
3/θ - 4/(1-θ) = 0 3(1-θ) - 4θ = 0 3 - 3θ - 4θ = 0 3 - 7θ = 0 7θ = 3 θ̂̂ = 3/7
5.	Проверка на максимум (вторая производная):
Чтобы убедиться, что найденное значение θ̃ действительно соответствует максимуму функции правдоподобия, найдем вторую производную логарифма функции правдоподобия:
d²(ln L(θ))/dθ² = -3/θ² - 4/(1-θ)²
Подставим найденное значение θ̃ = 3/7:
d²(ln L(θ̃))/dθ² = -3/(3/7)² - 4/(1-3/7)² = -3/(9/49) - 4/(16/49) = -147/9 - 196/16 = -49/3 - 49/4 = (-196 - 147)/12 = -343/12 < 0
Поскольку вторая производная отрицательна, найденное значение θ̂ соответствует максимуму.
Ответ: Оценка параметра θ методом максимального правдоподобия равна θ̂̂ = 3/7.
        """
    if var == 23:
        text = """Найдите оценку методом наибольшего правдоподобия для параметра сдвига θ в модели распределения Коши:
f(x) = 1/(π(1+(x-θ)²)), θ ∈ ℝ.
по выборке из двух наблюдений: x₁ = -1, x₂ = 1.
Решение (корректное):
1.	Функция правдоподобия:
L(θ; x₁, x₂) = 1/(π²(1+(-1-θ)²)(1+(1-θ)²))
2.	Логарифм функции правдоподобия:
ln L(θ) = -2ln(π) - ln(1+(1+θ)²) - ln(1+(1-θ)²)
3.	Производная логарифма функции правдоподобия по θ:
d(ln L(θ))/dθ = 2(1+θ)/(1+(1+θ)²) + 2(1-θ)/(1+(1-θ)²)
4.	Приравниваем производную к нулю:
(1+θ)/(1+(1+θ)²) + (1-θ)/(1+(1-θ)²) = 0
Приводим к общему знаменателю:
(1+θ)(1+(1-θ)²) + (1-θ)(1+(1+θ)²) = 0 (1+θ)(1+1-2θ+θ²) + (1-θ)(1+1+2θ+θ²) = 0 (1+θ)(2-2θ+θ²) + (1-θ)(2+2θ+θ²) = 0 2-2θ+θ²+2θ-2θ²+θ³ + 2+2θ+θ²-2θ-2θ²-θ³ = 0 4 - 2θ² = 0 θ² = 2 θ = ±√2
5.	Анализ с помощью второй производной:
Вторая производная логарифма правдоподобия довольно сложная. Вместо этого рассмотрим поведение функции правдоподобия.
L(θ) = 1/(π²(1+(1+θ)²)(1+(1-θ)²))
Заметим, что функция симметрична относительно θ = 0.
o	При θ = 0: L(0) = 1/(π²(1+1)(1+1)) = 1/(4π²)
o	При θ = ±√2: L(±√2) = 1/(π²(1+3+2√2)(1+3-2√2)) = 1/(π²(4+2√2)(4-2√2)) = 1/(π²(16-8)) = 1/(8π²)
Так как 1/(4π²) > 1/(8π²), функция правдоподобия достигает максимума при θ = 0.
6.	Геометрическая интерпретация:
Распределение Коши симметрично относительно θ. В нашем случае наблюдения x₁ = -1 и x₂ = 1 также симметричны относительно 0. Интуитивно понятно, что центр распределения, максимизирующий правдоподобие, должен находиться в центре между наблюдениями, то есть в точке 0.
Ответ: Оценка параметра θ методом максимального правдоподобия: θ̂ = 0
        """
    if var == 24:
        text = """Случайная величина Х представляет собой продолжительность безотказной работы элемента электронной аппаратуры. Известно, что ее распределение подчиняется закону Релея с плотностью распределения:
f(x) = (2x/θ) * exp(-x²/θ), x ≥ 0.
Требуется найти оценку θ̂ неизвестного значения параметра θ методом максимального правдоподобия.
Решение:
1.	Функция правдоподобия:
Пусть x₁, x₂, ..., xₙ — выборка из распределения Релея. Функция правдоподобия имеет вид:
L(θ; x₁, ..., xₙ) = Πᵢ (2xᵢ/θ) * exp(-xᵢ²/θ) = (2ⁿ/θⁿ) * (Πᵢ xᵢ) * exp(-Σᵢ xᵢ²/θ)
2.	Логарифм функции правдоподобия:
ln L(θ) = n ln(2) - n ln(θ) + Σᵢ ln(xᵢ) - (1/θ) * Σᵢ xᵢ²
3.	Производная логарифма функции правдоподобия по θ:
d(ln L(θ))/dθ = -n/θ + (1/θ²) * Σᵢ xᵢ²
4.	Приравниваем производную к нулю и решаем уравнение:
-n/θ + (1/θ²) * Σᵢ xᵢ² = 0 -nθ + Σᵢ xᵢ² = 0 θ̂ = (1/n) * Σᵢ xᵢ²
Ответ: Оценка параметра θ методом максимального правдоподобия: θ̂ = (1/n) * Σᵢ xᵢ²
        """
    if var == 25:
        text = """В таблице представлены данные по числу сделок на фондовой бирже за квартал для 400 инвесторов:
| xᵢ | 0 | 1 | 2 | 3 | 4 | 5 | 6 | 7 | 8 | 9 | 10 |
| nᵢ | 140 | 95 | 77 | 36 | 19 | 17 | 6 | 4 | 3 | 1 | 2 |
В предположении, что случайное число сделок описывается распределением Пуассона, оценить параметр λ методом моментов. Определить вероятность того, что число сделок за квартал будет не менее трёх, применяя метод моментов, и непосредственно по таблице.
1.	Оценка λ методом моментов:
Для распределения Пуассона E(X) = λ. Методом моментов приравниваем выборочное среднее к теоретическому:
X̄ = (0140 + 195 + 277 + 336 + 419 + 517 + 66 + 74 + 83 + 91 + 10*2) / 400 X̄ = (0 + 95 + 154 + 108 + 76 + 85 + 36 + 28 + 24 + 9 + 20) / 400 X̄ = 635 / 400 = 1.5875
Таким образом, оценка параметра λ методом моментов:
λ̂ = 1.5875
2.	Вероятность того, что число сделок за квартал будет не менее трёх (по методу моментов):
Используя оценку λ̂ = 1.5875, мы можем аппроксимировать вероятность P(X ≥ 3) с помощью распределения Пуассона:
P(X ≥ 3) = 1 - P(X < 3) = 1 - [P(X=0) + P(X=1) + P(X=2)]
P(X=k) = (e^(-λ) * λ^k) / k!
P(X=0) = (e^(-1.5875) * 1.5875⁰) / 0! ≈ 0.205 P(X=1) = (e^(-1.5875) * 1.5875¹) / 1! ≈ 0.326 P(X=2) = (e^(-1.5875) * 1.5875²) / 2! ≈ 0.259
P(X ≥ 3) = 1 - (0.205 + 0.326 + 0.259) = 1 - 0.79 ≈ 0.21
3.	Вероятность того, что число сделок за квартал будет не менее трёх (непосредственно по таблице):
P(X ≥ 3) = (36 + 19 + 17 + 6 + 4 + 3 + 1 + 2) / 400 = 88 / 400 = 0.22
Ответ:
•	Оценка параметра λ методом моментов: λ̂ = 1.5875
•	Вероятность P(X ≥ 3) по методу моментов: ≈ 0.21
•	Вероятность P(X ≥ 3) непосредственно по таблице: 0.22
        """
    if var == 26:
        text = """2. 

        """
    if var == 27:
        text = """Пусть X₁, ..., Xₙ — выборка из дискретного распределения:
Pₑ(X=-1) = θ, Pₑ(X=1) = 4θ, Pₑ(X=2) = 2θ, Pₑ(X=0) = 1 - 7θ, θ ∈ (0; 1/7).
Найдите оценку параметра θ по методу максимального правдоподобия. Проверить полученную оценку на несмещённость и состоятельность.
Решение:
1.	Функция правдоподобия:
Пусть в выборке из n наблюдений:
•	n₋₁ – количество наблюдений X = -1
•	n₁ – количество наблюдений X = 1
•	n₂ – количество наблюдений X = 2
•	n₀ – количество наблюдений X = 0
Тогда функция правдоподобия имеет вид:
L(θ; x₁, ..., xₙ) = θⁿ⁻¹ * (4θ)ⁿ¹ * (2θ)ⁿ² * (1 - 7θ)ⁿ⁰ = 4ⁿ¹ * 2ⁿ² * θ^(n₋₁ + n₁ + n₂) * (1 - 7θ)ⁿ⁰
Заметим, что n₋₁ + n₁ + n₂ + n₀ = n, откуда n₋₁ + n₁ + n₂ = n - n₀. Таким образом,
L(θ) = 4ⁿ¹ * 2ⁿ² * θ^(n - n₀) * (1 - 7θ)ⁿ⁰
2.	Логарифм функции правдоподобия:
ln L(θ) = n₁ln(4) + n₂ln(2) + (n - n₀)ln(θ) + n₀ln(1 - 7θ)
3.	Производная логарифма функции правдоподобия по θ:
d(ln L(θ))/dθ = (n - n₀)/θ - 7n₀/(1 - 7θ)
4.	Приравниваем производную к нулю и решаем уравнение:
(n - n₀)/θ - 7n₀/(1 - 7θ) = 0
Приводим к общему знаменателю:
(n - n₀)(1 - 7θ) - 7n₀θ = 0 n - 7nθ - n₀ + 7n₀θ - 7n₀θ = 0 n - n₀ - 7nθ = 0 7nθ = n - n₀ θ̂ = (n - n₀) / (7n)
5.	Проверка на несмещённость:
Оценка θ̂ является несмещённой, если E(θ̂) = θ. Проверим это:
E(n₀) = n * P(X=0) = n(1 - 7θ)
E(θ̂) = E((n - n₀) / (7n)) = (1/(7n)) * E(n - n₀) = (1/(7n)) * (n - E(n₀)) = (1/(7n)) * (n - n(1 - 7θ)) = (1/(7n)) * (n - n + 7nθ) = (1/(7n)) * 7nθ = θ
Следовательно, E(θ̂) = θ, и оценка θ̂ несмещённая.
6.	Проверка на состоятельность:
Оценка состоятельна, если при n → ∞ она сходится по вероятности к истинному значению параметра θ. Для этого достаточно показать, что оценка несмещенная и ее дисперсия стремится к нулю при n → ∞. Несмещенность мы уже доказали. Найдем дисперсию:
Var(θ̂) = Var((n - n₀) / (7n)) = (1/(49n²)) * Var(n - n₀) = (1/(49n²)) * Var(n₀)
Так как n₀ имеет биномиальное распределение с параметрами n и (1 - 7θ), то Var(n₀) = n(1 - 7θ)(7θ).
Var(θ̂) = (1/(49n²)) * n(1 - 7θ)(7θ) = (7θ(1 - 7θ)) / (49n) = (θ(1 - 7θ)) / (7n)
При n → ∞, Var(θ̂) → 0.
Следовательно, оценка θ̂ является состоятельной.
Ответ: Оценка параметра θ методом максимального правдоподобия: θ̂ = (n - n₀) / (7n). Оценка является несмещенной и состоятельной.
        """
    if var == 27:
        text = """Пусть X₁, ..., Xₙ — выборка из дискретного распределения:
Pₑ(X=-1) = θ, Pₑ(X=1) = 4θ, Pₑ(X=2) = 2θ, Pₑ(X=0) = 1 - 7θ, θ ∈ (0; 1/7).
Найдите оценку параметра θ по методу максимального правдоподобия. Проверить полученную оценку на несмещённость и состоятельность.
Решение:
1.	Функция правдоподобия:
Пусть в выборке из n наблюдений:
•	n₋₁ – количество наблюдений X = -1
•	n₁ – количество наблюдений X = 1
•	n₂ – количество наблюдений X = 2
•	n₀ – количество наблюдений X = 0
Тогда функция правдоподобия имеет вид:
L(θ; x₁, ..., xₙ) = θⁿ⁻¹ * (4θ)ⁿ¹ * (2θ)ⁿ² * (1 - 7θ)ⁿ⁰ = 4ⁿ¹ * 2ⁿ² * θ^(n₋₁ + n₁ + n₂) * (1 - 7θ)ⁿ⁰
Заметим, что n₋₁ + n₁ + n₂ + n₀ = n, откуда n₋₁ + n₁ + n₂ = n - n₀. Таким образом,
L(θ) = 4ⁿ¹ * 2ⁿ² * θ^(n - n₀) * (1 - 7θ)ⁿ⁰
2.	Логарифм функции правдоподобия:
ln L(θ) = n₁ln(4) + n₂ln(2) + (n - n₀)ln(θ) + n₀ln(1 - 7θ)
3.	Производная логарифма функции правдоподобия по θ:
d(ln L(θ))/dθ = (n - n₀)/θ - 7n₀/(1 - 7θ)
4.	Приравниваем производную к нулю и решаем уравнение:
(n - n₀)/θ - 7n₀/(1 - 7θ) = 0
Приводим к общему знаменателю:
(n - n₀)(1 - 7θ) - 7n₀θ = 0 n - 7nθ - n₀ + 7n₀θ - 7n₀θ = 0 n - n₀ - 7nθ = 0 7nθ = n - n₀ θ̂ = (n - n₀) / (7n)
5.	Проверка на несмещённость:
Оценка θ̂ является несмещённой, если E(θ̂) = θ. Проверим это:
E(n₀) = n * P(X=0) = n(1 - 7θ)
E(θ̂) = E((n - n₀) / (7n)) = (1/(7n)) * E(n - n₀) = (1/(7n)) * (n - E(n₀)) = (1/(7n)) * (n - n(1 - 7θ)) = (1/(7n)) * (n - n + 7nθ) = (1/(7n)) * 7nθ = θ
Следовательно, E(θ̂) = θ, и оценка θ̂ несмещённая.
6.	Проверка на состоятельность:
Оценка состоятельна, если при n → ∞ она сходится по вероятности к истинному значению параметра θ. Для этого достаточно показать, что оценка несмещенная и ее дисперсия стремится к нулю при n → ∞. Несмещенность мы уже доказали. Найдем дисперсию:
Var(θ̂) = Var((n - n₀) / (7n)) = (1/(49n²)) * Var(n - n₀) = (1/(49n²)) * Var(n₀)
Так как n₀ имеет биномиальное распределение с параметрами n и (1 - 7θ), то Var(n₀) = n(1 - 7θ)(7θ).
Var(θ̂) = (1/(49n²)) * n(1 - 7θ)(7θ) = (7θ(1 - 7θ)) / (49n) = (θ(1 - 7θ)) / (7n)
При n → ∞, Var(θ̂) → 0.
Следовательно, оценка θ̂ является состоятельной.
Ответ: Оценка параметра θ методом максимального правдоподобия: θ̂ = (n - n₀) / (7n). Оценка является несмещенной и состоятельной.
        """
    if var == 29:
        text = """Давайте полностью решим задачу 4 из билета №29.
4. По выборке объёма n = 18, извлечённой из нормальной генеральной совокупности с известным средним квадратичным отклонением σ = 4, при уровне значимости 0,03 проверяется нулевая гипотеза H₀: μ = μ₀ = 17. Требуется: а) найти мощность критерия для проверки гипотезы H₁: μ = μ₁ = 19.6; б) найти объём выборки n, при котором мощность критерия не меньше 0,84.
Решение:
а) Найти мощность критерия:
1.	Формулировка гипотез:
o	H₀: μ = 17
o	H₁: μ = 19.6
2.	Критическая область: Так как σ известно, используем z-критерий. Уровень значимости α = 0.03. Для двусторонней гипотезы α/2 = 0.015. По таблице Z-распределения находим z₀.₀₁₅ ≈ 2.17. Критическая область определяется как:
|(X̄ - μ₀) / (σ/√n)| > z₀.₀₁₅
|(X̄ - 17) / (4/√18)| > 2.17
Отсюда получаем два критических значения для выборочного среднего X̄:
X̄ > 17 + 2.17 * (4/√18) ≈ 17 + 2.05 ≈ 19.05 X̄ < 17 - 2.17 * (4/√18) ≈ 17 - 2.05 ≈ 14.95
Таким образом, критическая область: X̄ < 14.95 или X̄ > 19.05
3.	Мощность критерия: Мощность критерия — это вероятность отвергнуть нулевую гипотезу H₀, когда верна альтернативная гипотеза H₁. То есть P(отвергнуть H₀ | H₁ верна), или P(X̄ ∈ критическая область | μ = 19.6).
Мощность = P(X̄ < 14.95 | μ = 19.6) + P(X̄ > 19.05 | μ = 19.6)
Преобразуем к стандартному нормальному распределению Z:
P(Z < (14.95 - 19.6) / (4/√18)) + P(Z > (19.05 - 19.6) / (4/√18)) P(Z < -4.65 / 0.94) + P(Z > -0.55 / 0.94) P(Z < -4.95) + P(Z > -0.59)
P(Z < -4.95) ≈ 0 (эта вероятность очень мала и ею можно пренебречь). P(Z > -0.59) = 1 - P(Z < -0.59) = P(Z < 0.59) ≈ 0.7224 (по таблице Z-распределения).
Мощность критерия ≈ 0.7224
б) Найти объём выборки n, при котором мощность критерия не меньше 0,84:
Нам нужно найти n, при котором мощность критерия будет не менее 0.84. Так как вероятность P(X̄ < 14.95) при μ=19.6 пренебрежимо мала, достаточно рассмотреть условие:
P(X̄ > 19.05 | μ = 19.6) ≥ 0.84
P(Z > (19.05 - 19.6) / (4/√n)) ≥ 0.84
P(Z > (-0.55√n) / 4) ≥ 0.84
P(Z < (0.55√n) / 4) ≥ 0.84
По таблице Z-распределения находим значение z, для которого P(Z < z) ≈ 0.84. Это значение приблизительно равно 1.
(0.55√n) / 4 ≈ 1 0.55√n ≈ 4 √n ≈ 4 / 0.55 ≈ 7.27 n ≈ 7.27² ≈ 52.85
Округляем n до ближайшего большего целого числа, так как нам нужно не менее 0.84 мощности:
n = 53
Ответ:
а) Мощность критерия при n = 18 и μ₁ = 19.6 ≈ 0.7224. б) Объём выборки n, при котором мощность критерия не меньше 0.84, равен 53.
        """
    if var == 30:
        text = """Пусть x⃗=(x₁, ..., x₃₅) – реализация выборки X⃗=(X₁, ..., X₃₅) из нормального распределения N(μ; σ²). Проверяется на уровне значимости α=0,02 гипотеза H₀: σ=1.12 против H₁: σ≠1.12.
1.	Найти значение χ²; 2) Найти границы А и В критического множества и проверить H₀; 3) Найти Р-значение критерия; 4) Найти вероятность ошибки второго рода β и мощность W для σ₁=1.34. Исходные данные в файле ЭкзБ_30-4.csv
import pandas as pd
import numpy as np
from scipy import stats

# 1. Загрузка данных (замените 'ЭкзБ_30-4.csv' на имя вашего файла)
try:
    data = pd.read_csv('ЭкзБ_30-4.csv', header=None, names=['x'])  # Предполагаем, что данные в одном столбце без заголовка
except FileNotFoundError:
    print("Ошибка: Файл 'ЭкзБ_30-4.csv' не найден. Пожалуйста, убедитесь, что файл находится в текущей директории или укажите правильный путь.")
    exit() #Завершаем выполнение программы если файл не найден

x = data['x'].values
n = len(x)
sigma0 = 1.12
alpha = 0.02

# 2. Вычисление выборочной дисперсии s^2
s2 = np.var(x, ddof=1)  # ddof=1 для несмещенной оценки

# 3. Вычисление статистики χ²
chi2 = (n - 1) * s2 / (sigma0**2)
print(f"Значение χ²: {chi2}")

# 4. Границы критического множества
a = stats.chi2.ppf(1 - alpha/2, n - 1)
b = stats.chi2.ppf(alpha/2, n - 1)
print(f"Границы критического множества: A = {a:.2f}, B = {b:.2f}")

# 5. Проверка гипотезы H₀
if chi2 < b or chi2 > a:
    print("Нулевая гипотеза H₀ отвергается.")
else:
    print("Нулевая гипотеза H₀ не отвергается.")

# 6. P-значение
p_value = 2 * min(stats.chi2.cdf(chi2, n - 1), 1 - stats.chi2.cdf(chi2, n - 1))
print(f"P-значение: {p_value:.4f}")

if p_value < alpha:
    print("Нулевая гипотеза H₀ отвергается (по P-значению).")
else:
    print("Нулевая гипотеза H₀ не отвергается (по P-значению).")


# 7. Вероятность ошибки второго рода β и мощность W для σ₁=1.34
sigma1 = 1.34
non_centrality = (n-1)*sigma0**2/sigma1**2
beta = stats.ncchi2.cdf(a, n-1, non_centrality)-stats.ncchi2.cdf(b, n-1, non_centrality)
W = 1 - beta
print(f"Вероятность ошибки второго рода β: {beta:.4f}")
print(f"Мощность критерия W: {W:.4f}")
        """
    return text